{}

{$A+,B+,D-,E+,F+,I+,L-,N-,O+,R-,S+,V-}
unit common;

interface

uses
  OPcrt,dos,myio,tmpcom,timejunk ;

{$I FuncKeys.pas}
{$I Bd052.pas   }


const strlen=160;
      dsaves:integer=0;
      BOXEDTITLE='`#[';
      sepr2=#3#4+':'+#3#3;

{$I LinkVar.Pas}

type f_initexecswap = Function (p:pointer; s:string):boolean;
     f_execwithswap = Function (p,c:string):word;
     p_shutdownexecswap = Procedure ;

var initexecswap2:f_initexecswap;
    execwithswap2:f_execwithswap;
    shutdownexecswap2:p_shutdownexecswap;

var EditorFile : File Of EditorRecord; { Editors.Dat }
    uf:file of userrec;           { USER.LST                              }
    xf:file of protrec;           { PROTOCOL.DAT                          }
    ulf:file of ulrec;            { UPLOADS.DAT                           }
    ulff:file of ulfrec;          { *.DIR                                 }
    sf:file of smalrec;           { NAMES.LST                             }
    smf:file of smr;              { SHORTMSG.DAT                          }
    verbf:file of verbrec;        { VERBOSE.DAT                           }

(* ********************           ********************** *)
               { Message base variables }
    BrdsFile   : File of MsgBoardsRecord;{ MsgBrds.DAT                    }
    Brd        : MsgBoardsRecord;        { Current Brd in memory          }
    MsgOn      : Longint;              { Message Number reading/On        }
    Board,                             { Message Board User is IN         }
    MaxBoards  : Word;                 { MaxNumber of Message bases       }
(* ********************            ********************* *)

    sysopf,                       { SYSOP.LOG                             }
    sysopf1,                      { SLOGxxxx.LOG                          }
    trapfile,                     { TRAP*.MSG                             }
    cf:text;                      { CHAT*.MSG                             }

    systat:systatrec;             { configuration information             }
    fstring:fstringrec;           { string configuration                  }
    fidor:fidorec;                { FidoNet information                   }

    ThisUser : Userrec;             { user's account records                }
{   Editor   : EditorRecord;         Editor Command Records }
    macros   : macrorec;            { user's macros, if any                 }
    zscanr   : zscanrec;            { user's zscan records                  }

    { EVENTS }
    Events:array[0..maxevents] of ^eventrec;
    Numevents:integer;            { # of events                           }

    { PROTOCOLS }
    protocol:protrec;             { protocol in memory                    }
    numprotocols:integer;         { # of protocols                        }

    { FILE BASES }
    memuboard,tempuboard:ulrec;   { uboard in memory, temporary uboard    }
    readuboard,                   { current uboard # in memory            }
    maxulb,                       { # of file bases                       }
    fileboard:integer;            { file base user is in                  }

    { FILE BASE COMPRESSION TABLES }
    ccuboards:array[0..1,0..MaxUBoards] of Word;
    ccboards : Array[0..1,0..MaxMsgBoards] of Word;

    spd:string[6];                { current modem speed, "KB" for local   }
    spdarq:boolean;               { whether modem connected with ARQ      }
    Node  : Byte;                 { BBS Node Number !!! }
(*****************************************************************************)

    HotKeyHit : Char;             { HotKey Pressed in screen print...     }
    buf:string[255];              { macro buffer                          }
    sitedatetime:packdatetime;    { last time site compiled/changed status }
    vercs:string;
    vertypes:byte;                { Alpha/Beta/etc, Registered, Node      }
    chatr,                        { last chat reason                      }
    cmdlist,                      { list of cmds on current menu          }
    licenseinfo,                  { licensing info, if present            }
    ll,                           { "last-line" string for word-wrapping  }
    start_dir:string;             { directory BBS was executed from       }

    tim,                          { time last keystroke entered           }
    timeon:datetimerec;           { time user logged on                   }

    choptime,                     { time to chop off for system events    }
    extratime,                    { extra time - given by F7/F8, etc      }
    freetime,                     { free time                             }
    oltime:real;

    answerbaud,                   { baud rate to answer the phone at      }
    exteventtime,                 { # minutes before external event       }
    maxheapspace : LongInt;       { max heap space available              }
    serialnumber:string;          { serial number, if present             }

    chatt,                        { number chat attempts made by user     }
    etoday,                       { E-mail sent by user this call         }
    lastprot,                     { last protocol #                       }
    ldate,                        { last daynum()                         }
    lil,                          { lines on screen since last pausescr() }
    mread,                        { # public messages has read this call  }
    pap,                          { characters on this line so far        }
    ptoday,                       { posts made by user this call          }
    realdsl,                      { real DSL level of user                }
    realsl,                       { real SL level of user (for F9)        }
    usernum:integer;              { user's user number                    }
    chelplevel,                   { current help level                    }
    curco,                        { current ANSI color                    }
    elevel : Byte;                { ERRORLEVEL to exit with               }

const
    allowabort:boolean=TRUE;      { are aborts allowed?                   }
    echo:boolean=TRUE;            { is text being echoed? (FALSE=use echo chr)}
    flistverb:boolean=TRUE;       { list verbose descriptions?            }
    hangup:boolean=TRUE;          { is user offline now?                  }
    nofile:boolean=TRUE;          { did last pfl() file NOT exist?        }
    onekcr:boolean=TRUE;          { does ONEK prints<CR> upon exit?       }
    onekda:boolean=TRUE;          { does ONEK display the choice?         }
    slogging:boolean=TRUE;        { are we outputting to the SysOp log?   }
    sysopon:boolean=TRUE;         { is SysOp logged onto the WFC menu?    }
    wantout:boolean=TRUE;         { output text locally?                  }
    wcolor:boolean=TRUE;          { in chat: was last key pressed by SysOp? }

    badfpath:boolean=FALSE;       { is the current DL path BAD?           }
    badufpath:boolean=FALSE;      { is the current UL path BAD?           }
    badini:boolean=FALSE;         { was last call to ini/inu value()=0, s<>"0"? }

    beepend:boolean=FALSE;        { whether to beep after caller logs off }
    bnp:boolean=FALSE;            { was file base name printed yet?       }
    cfilteron:boolean=FALSE;      { is the color filter on?               }
    cfo:boolean=FALSE;            { is chat file open?                    }
    ch:boolean=FALSE;             { are we in chat mode?                  }
    chatcall:boolean=FALSE;       { is the chat call "noise" on?          }
    checkit:boolean=FALSE;        { }
    croff:boolean=FALSE;          { are CRs turned off?                   }
    ctrljoff:boolean=FALSE;       { turn color to #1 after ^Js??          }
    cwindowon:boolean=FALSE;      { is SysOp window ON?                   }
    doneafternext:boolean=FALSE;  { offhook and exit after next logoff?   }
    doneday:boolean=FALSE;        { are we done now? ready to drop to DOS? }
    dosansion:boolean=FALSE;      { output chrs to DOS for ANSI codes?!!? }
    dyny:boolean=FALSE;           { does YN return Yes as default?        }
    enddayf:boolean=FALSE;        { perfrom "endday" after logoff?        }
    fastlogon:boolean=FALSE;      { if a FAST LOGON is requested          }
    hungup:boolean=FALSE;         { did user drop carrier?                }
    incom:boolean=FALSE;          { accepting input from com?             }

    inwfcmenu:boolean=FALSE;      { are we in the WFC menu?               }
    readingmail:boolean=FALSE;    { is user reading messaages- Used for MCI codes  }
    lastcommandgood:boolean=FALSE;{ was last command a REAL command?      }
    lastcommandovr:boolean=FALSE; { override PAUSE? (NO pause?)           }
    macok:boolean=FALSE;          { are macros OKay right now?            }

    localioonly:boolean=FALSE;    { local I/O ONLY?                       }

    mtcfilteron:boolean=FALSE;    { Manhattan Transfer color-filter active }
    mtcolors:boolean=FALSE;       { Manhattan Transfer colors in use      }
    newmenutoload:boolean=FALSE;  { menu command returns TRUE if new menu to load }
    nightly:boolean=FALSE;        { execute hard-coded nightly event?     }
    nofeed:boolean=FALSE;         { }
    nopfile:boolean=FALSE;        { }
    overlayinems:boolean=FALSE;   { is overlay file in EMS memory?        }
    outcom:boolean=FALSE;         { outputting to com?                    }
    printingfile:boolean=FALSE;   { are we printing a file?               }
    quitafterdone:boolean=FALSE;  { quit after next user logs off?        }

    shutupchatcall:boolean=FALSE; { was chat call "SHUT UP" for this call? }
    smread:boolean=FALSE;         { were "small messages" read? (delete them) }
    trapping:boolean=FALSE;       { are we trapping users text?           }

    useron:boolean=FALSE;         { is there a user on right now?         }
    wantfilename:boolean=FALSE;   { display message filename in scan?     }
    wascriterr:boolean=FALSE;     { critical error during last call?      }
    wasguestuser:boolean=FALSE;   { did a GUEST USER log on?              }
    wasnewuser:boolean=FALSE;     { did a NEW USER log on?                }
    telluserevent:byte=0;     { has user been told about the up-coming event? }
    exiterrors:byte=254;      { ERRORLEVEL for Critical Error exit    }
    exitnormal:byte=255;      { ERRORLEVEL for Normal exit            }

    unlisted_filepoints=5;    { file points for unlisted downloads    }

var
    first_time:boolean;           { first time loading a menu?            }
    menustack:array[1..8] of string[12]; { menu stack                     }
    menustackptr:integer;         { menu stack pointer                    }
    last_menu,                    { last menu loaded                      }
    curmenu:string;                 { current menu loaded                   }
    menur:menurec;                { menu information                      }
    cmdr:array[1..50] of commandrec; { command information                }
    noc:integer;                  { # of commands on menu                 }
    fqarea,mqarea:boolean;        { file/message quick area changes       }

    doit,doitt:boolean;
    newdate:string[8];            { NewScan pointer date                  }
    lrn:integer;                  { last record # for recno/nrecno        }
    lfn:string;                   { last filename for recno/nrecno        }

    batchtime:real;               { }
    numbatchfiles:integer;        { # files in DL batch queue             }
    batch:array[1..20] of record
      fn:string[65];
      section:integer;
      pts:integer;
      blks:longint;
      tt:real;
    End;

    numubatchfiles:integer;       { # files in UL batch queue }
    ubatch:array[1..maxubatchfiles] of record
      fn:string[12];
      section:integer;
      description:string[65];
      vr:byte;
    End;
    ubatchv:array[1..maxubatchfiles] of ^verbrec;
    hiubatchv:integer;


Procedure sprompt(s:string);  (* Send STRING with User Color Checking, But LF+CR *)

Function  timer:real;
Procedure newcomptables;
Procedure cline(var s:string; dd:string);
Function  ageuser(bday:string):integer;     (* returns age of user by birthdate *)
Procedure remove_port;
Procedure iport;
Procedure InitFossil(CPort : Byte;BPS : LongInt);
Function  getwindysize(wind:integer):integer;
Procedure commandline(s:string);
Procedure sclearwindow;
Procedure schangewindow(needcreate:boolean; newwind:integer);
Function  ccinkey1:char;
Procedure gameport;
Procedure sendcom1(c:char);
Function  recom1(var c:char):boolean;
Procedure term_ready(ready_status:boolean);
Function  intime(tim:real; tim1,tim2:integer):boolean;
                    (* check whether in time range *)
Function  checkpw:boolean;
Function  stripcolor(o:string):string;
Procedure sl1(s:string);
Procedure sysoplog(s:string);
Function  tch(s:string):string;
Function  time:string;
Function  date:string;
Procedure shelldos(bat:boolean; cl:string; var rcode:integer);
Procedure sysopshell(takeuser:boolean);
Procedure readinzscan;
Procedure savezscanr;
Procedure redrawforansi;
Function  days(mo,yr:integer):integer;
Function  daycount(mo,yr:integer):integer;
Function  daynum(dt:string):integer;
Function  dat:string;
Procedure getkey(var c:char);
Procedure pr1(s:string);
Procedure pr(s:string);
Procedure sde; {* restore curco colors (DOS and tc) loc. after local *}
Procedure sdc;
Procedure setc(c:byte);
Procedure cl(c:integer);
Procedure dosansi(c:char);
Procedure prompt(s:string);
Function  sqoutsp(s:string):string;
Function  mln(s:string; l:integer):string;
Function  mlnnomci(s:string; l:integer):string;
Function  mlnmci(s:string; l:integer):string;
Function  mrn(s:string; l:integer):string;
Function  mn(i,l:longint):string;
Procedure pausescr;
Procedure print(s:string);
Procedure nl;
Procedure prt(s:string);
Procedure mpl(c:integer);
Procedure tleft;
Procedure prestrict(u:userrec);
Procedure topscr;
Procedure readinmacros;
Procedure saveuf;                               { Saves user file }
Procedure loadurec(var u:userrec; i:integer);   { Load User record }
Procedure saveurec(u:userrec; i:integer);       { Save User Record Number }
Function  empty:boolean;
Function  inkey:char;
Procedure outkey(c:char);
Procedure dm(i:string; var c:char);
Procedure cls;
Procedure wait(b:boolean);
Procedure swac(var u:userrec; r:uflags);
Function  tacch(c:char):uflags;
Procedure acch(c:char; var u:userrec);
Procedure sprint(s:string);
Procedure lcmds(len,c:byte; c1,c2:string);
Procedure autovalidate(var u:userrec; un:integer); { Validate UserNum UN }
Procedure rsm;
Procedure inittrapfile;
Procedure chatfile(b:boolean);
Procedure inu(var i:integer);
Procedure ini(var i:byte);
Procedure inputwn1(var v:string; l:integer; flags:string; var changed:boolean);
Procedure inputwn(var v:string; l:integer; var changed:boolean);
Procedure inputwnwc(var v:string; l:integer; var changed:boolean);
Procedure inputmain(var s:string; ml:integer; flags:string);
Procedure inputwc(var s:string; ml:integer);
Procedure input(var s:string; ml:integer);
Procedure inputl(var s:string; ml:integer);
Procedure inputcaps(var s:string; ml:integer);
Procedure onek(var c:char; ch:string);
Procedure local_input1(var i:string; ml:integer; tf:boolean);
Procedure local_input(var i:string; ml:integer);
Procedure local_inputl(var i:string; ml:integer);
Procedure local_onek(var c:char; ch:string);
Procedure wkey(var abort,next:boolean);
Function  ctim(rl:real):string;
Function  tlef:string;
Procedure printa1(s:string; var abort,next:boolean);

 { Print using #charaters and abort feature }
Procedure printacr(s:string; var abort,next:boolean);
Function  longtim(dt:datetimerec):string;
Function  dt2r(dt:datetimerec):real;
Procedure r2dt(r:real; var dt:datetimerec);
Procedure timediff(var dt:datetimerec; dt1,dt2:datetimerec);
Procedure getdatetime(var dt:datetimerec);
Procedure pfl(fn:string; var abort,next:boolean; cr:boolean);
Procedure printfile(fn:string);                 { Print ansi/ascii.ext file }
Function  exist(fn:string):boolean;              { Does Fn exist? }
Procedure printf(fn:string);                    { print ans/msg file, no extention }
Procedure mmkey(var s:string);

Procedure com_flush_rx;
Function  com_carrier:boolean;
Function  com_rx_empty:boolean;
Function Fossil_Description(ComPort:Byte):String;

Procedure chat;
Procedure skey(c:char);
Procedure showudstats;
Procedure skey1(c:char);
Function  verline(i:integer):string;
Function  aacs1(u:userrec; un:integer; s:string):boolean;
Function  aacs(s:string):boolean;

Procedure DisableInterrupts;
Procedure EnableInterrupts;


Procedure LoopLock(Var FHandle : File);     { Loop to run when Ioresult = 162}
Procedure ErrorLocking(Str : String);
Procedure ErrorUnLocking(Str : String);
Function  LockIt(Var FileHere : File): Boolean;    { Lock this file }
Function  UnLockIt (Var FileHere : File): boolean; { Unlock this file }
Procedure UserOnOtherNodes;
Function IsUserOn(N : Byte;Name:String): Boolean;
procedure dely(r:real);

Function  SoftwareName : string;          { Return Software name }
Procedure GetInput(Var S : String; Allowed:string);
Function  GetAddress(zone,net,node,point:integer):string;
Procedure SaveUserNum(user : UserRec; UserNumber : Longint);
Procedure BackUp(SpacesToDel : Integer);{ Delete 'Saving Message'}
                                        { messages and such,SpacesToDel is}
                                        { Length to backup on }

Function  AutoAnsi:boolean;      { Is the remote ansi capable? }
Function  lenn(s:string):integer;
Function  lennmci(s:string):integer;
Procedure loaduboard(i:integer);
Procedure tc(n:integer);
Function  mso:boolean;
Function  fso:boolean;
Function  cso:boolean;
Function  so:boolean;
Function  fbaseac(b:byte):boolean;
Procedure changefileboard(b:integer);
Function  freek(d:integer):longint;
Function  exdrv(s:string):byte;
Function  nma:integer;
Function  okansi:boolean;
Function  okavatar:boolean;
Function  nsl:real;
Procedure checkhangup;
Function  sysop1:boolean;
Function  sysop:boolean;
Function  value(s:string):longint;
Function  cstr(i:longint):string;   { Convert LongInt to String }
Function  nam:string;              { Cap thisuser + this users # }
Function  Allcaps(s:string):string;
Function  Caps(S:string): String;
Function  leapyear(yr:integer):boolean;
Procedure scc;    {* make local textcolor( = curco *}
Procedure ynq(s:string);
Function  smci(c:char):string;
Function  substone(src,old,new:string):string;
Function  checkeventday(i:integer; t:real):boolean;
Function  checkpreeventtime(i:integer; t:real):boolean;
Function  checkeventtime(i:integer; t:real):boolean;
Function  checkevents(t:real):integer;
Procedure doeventstuff;
Function  aonoff(b:boolean; s1,s2:string):string;
Function  onoff(b:boolean):string;
Function  syn(b:boolean):string;
Procedure pyn(b:boolean);
Function  yn:boolean;
Function  pynq(s:string):boolean;
Function  centre(s:string):string;
Function  cstrl(li:longint):string;
Function  cstrr(rl:real; base:integer):string;
Function  MakeLength(Len : Byte; Str : String) : String;
Procedure SendFileP(S:string);
Procedure ShowVersion;
Procedure InputPre(Var Str: String;Len : Integer);
procedure inputpassword(var s : string;len: integer);
Function  StripCH(Ch : Char; Str : String) : String;
Function  AddSlash(S: String) : String;
Function  StripSpaceEnd(Str: string) : string;

implementation

uses common1, common2, common3,Common4,Common5,Miscx,ApAnsi,OpString;

(*****************************************************************************\
 **
 **  These routines have been placed in the overlay to decrease the
 **  in-memory size of the BBS.  Routines that are used frequently, and are
 **  HIGHLY related to the overall speed of the BBS, have been kept out
 **  of the overlay file, and remain in memory at all times.
 **
\*****************************************************************************)
Function  Checkpw:boolean;
         Begin CheckPw:=common1.checkpw; End;
Function  LockIt(Var FileHere : File): Boolean;
         Begin lockit:=Common3.Lockit(FileHere); End;
Function  UnLockIt (Var FileHere : File): boolean;
         Begin UnLockit := Common3.UnLockit(FileHere); End;
Procedure ErrorLocking(Str : String);
          Begin Common3.ErrorLocking(Str); End;
Procedure ErrorUnLocking(Str : String);
          Begin Common3.ErrorUNLocking(Str); End;
Procedure RSM;
          Begin Common3.RSM; End;
Function  AutoAnsi:boolean;
         Begin AutoAnsi := Common4.AutoAnsi; End;
Function  AgeUser(bday:string):integer;
         Begin AgeUser := Common3.AgeUser(BDay); End;
Procedure CLS;  { Clear remote and local screen }
          Begin Common3.CLS; End;
Function  WaitAckFile(s:string):boolean;
         Begin WaitAckFile := Common3.WaitAckFile(s); End;
Procedure SendFileP(S:string);
          Begin Common3.SendFileP(S); End;
Procedure SysopLog(s:string);
          Begin Common3.SysOpLog(S); End;
Procedure SL1(s:string);
          Begin Common3.SL1(S); End;    { SysOp Log 1 }
Procedure OpenSysopF;
          Begin Common3.OpenSysopF; End;
Procedure Skey(c:char);
          Begin Common3.SKEY(C); End;  (* Global user keys *)
Function  Verline(i:integer):string;
         Begin Verline := Common3.Verline(I); End;  { Version Line }
Procedure BackUp(SpacesToDel : Integer);
          Begin Common3.BackUp(SpacesTODel); End;
Procedure newcomptables; Begin common1.newcomptables; End;
Procedure cline(var s:string; dd:string); Begin common1.cline(s,dd); End;
Procedure pausescr; Begin common1.pausescr; End;
Procedure wait(b:boolean); Begin common1.wait(b); End;
Procedure inittrapfile; Begin common1.inittrapfile; End;
Procedure chatfile(b:boolean); Begin common1.chatfile(b); End;
Procedure local_input1(var i:string; ml:integer; tf:boolean);
          Begin common1.local_input1(i,ml,tf); End;
Procedure local_input(var i:string; ml:integer);
          Begin common1.local_input(i,ml); End;
Procedure local_inputl(var i:string; ml:integer);
          Begin common1.local_inputl(i,ml); End;
Procedure local_onek(var c:char; ch:string);
          Begin common1.local_onek(c,ch); End;
Function  chinkey:char; Begin chinkey:=common1.chinkey; End;
Procedure inli1(var s:string); Begin common1.inli1(s); End;
Procedure chat; Begin common1.chat; End;
Procedure sysopshell(takeuser:boolean);
          Begin common1.sysopshell(takeuser); End;
Procedure globat(i:integer); Begin common1.globat(i); End;
Procedure exiterrorlevel; Begin common1.exiterrorlevel; End;
Procedure showsysfunc; Begin common1.showsysfunc; End;
Procedure readinzscan; Begin common1.readinzscan; End;
Procedure savezscanr; Begin common1.savezscanr; End;
Procedure redrawforansi; Begin common1.redrawforansi; End;

Procedure showudstats; Begin common2.showudstats; End;
Procedure skey1(c:char); Begin common2.skey1(c); End;
Procedure remove_port; Begin common2.remove_port; End;
Procedure iport; Begin common2.iport; End;
Procedure InitFossil(CPort : Byte;BPS : LongInt);
          Begin Common2.InitFossil(Cport,BPS); End;
Procedure gameport; Begin common2.gameport; End;
Procedure sendcom1(c:char); Begin common2.sendcom1(c); End;
Function  recom1(var c:char):boolean; Begin recom1:=common2.recom1(c); End;

Procedure term_ready(ready_status:boolean); Begin common2.term_ready(ready_status); End;
Function  getwindysize(wind:integer):integer; Begin getwindysize:=common2.getwindysize(wind); End;
Procedure commandline(s:string); Begin common2.commandline(s); End;
Procedure sclearwindow; Begin common2.sclearwindow; End;
Procedure schangewindow(needcreate:boolean; newwind:integer);
  Begin common2.schangewindow(needcreate,newwind); End;
Procedure topscr; Begin common2.topscr; End;
Procedure tleft; Begin common2.tleft; End;
Procedure readinmacros; Begin common2.readinmacros; End;
Procedure saveuf; Begin common2.saveuf; End;

Procedure inu(var i:integer); Begin common3.inu(i); End;
Procedure ini(var i:byte); Begin common3.ini(i); End;
Procedure inputwn1(var v:string; l:integer; flags:string; var changed:boolean);
  Begin common3.inputwn1(v,l,flags,changed); End;
Procedure inputwn(var v:string; l:integer; var changed:boolean);
  Begin common3.inputwn(v,l,changed); End;
Procedure inputwnwc(var v:string; l:integer; var changed:boolean);
  Begin common3.inputwnwc(v,l,changed); End;
Procedure inputmain(var s:string; ml:integer; flags:string);
  Begin common3.inputmain(s,ml,flags); End;
Procedure inputwc(var s:string; ml:integer); Begin common3.inputwc(s,ml); End;
Procedure input(var s:string; ml:integer); Begin common3.input(s,ml); End;
Procedure inputl(var s:string; ml:integer); Begin common3.inputl(s,ml); End;
Procedure inputcaps(var s:string; ml:integer);
  Begin common3.inputcaps(s,ml); End;
Procedure mmkey(var s:string); Begin common3.mmkey(s); End;

Procedure com_flush_rx; Begin tmpcom.com_flush_rx; End;
Function  com_carrier:boolean; Begin com_carrier:=tmpcom.com_carrier; End;
Function  com_rx_empty:boolean; Begin com_rx_empty:=tmpcom.com_rx_empty; End;
Function Fossil_Description(ComPort:Byte):String;
         Begin Fossil_Description := TmpCom.Fossil_Description(ComPort); End;
Function  SoftwareName;
         Begin softwarename := common3.softwarename; End;
Procedure GetInput(Var S : String; Allowed:string);
          Begin Common3.GetInput(s,Allowed); End;
Function  GetAddress(zone,net,node,point:integer):string;
         Begin GetAddress:= Common3.GetAddress(Zone,Net,Node,Point); End;
Function  lenn(s:string):integer;
         Begin lenn:= Common4.Lenn(s); End;
Function  lennmci(s:string):integer;
         Begin LennMci:= Common4.LennMci(s); End;
Procedure loaduboard(i:integer);
          Begin Common4.LoadUBoard(i); End;
Procedure tc(n:integer);
          Begin Common4.Tc(n); End;
Function  mso:boolean;
         Begin Mso := Common4.Mso; End;
Function  fso:boolean;
         Begin Fso := Common4.Fso; End;
Function  cso:boolean;
         Begin Cso := Common4.Cso; End;
Function  so:boolean;
         Begin SO:= Common4.SO; End;
Function  fbaseac(b:byte):boolean;
         Begin Fbaseac:= Common4.FbaseAc(b); End;
Procedure changefileboard(b:integer);
          Begin Common4.ChangeFileBoard(b); End;
Function  freek(d:integer):longint;
         Begin freek:= Common4.Freek(d); End;
Function  exdrv(s:string):byte;
         Begin Exdrv := Common4.ExDrv(s); End;
Function  nma:integer;
         Begin Nma := Common4.Nma; End;
Function  okansi:boolean;
         Begin OKAnsi := Common4.OKAnsi; End;
Function  okavatar:boolean;
         Begin OKAvatar := Common4.OKAvatar; End;
Function  nsl:real;
         Begin Nsl:= Common4.Nsl; End;
Procedure checkhangup;
          Begin Common4.CheckHangUp; End;
Function  sysop1:boolean;
         Begin SysOp1 := common4.SysOp1; End;
Function  sysop:boolean;
         Begin SysOp := Common4.Sysop; End;
Function  nam:string;
         Begin Nam := Common4.Nam; End;
Function  Caps(s:string):string;  { Cap first charaters... }
         Begin Caps:= Common4.Caps(s); End;
Function  leapyear(yr:integer):boolean;
         Begin LeapYear:= Common4.LeapYear(yr); End;
Procedure scc;
          Begin Common4.Scc; End;
Procedure ynq(s:string);
          Begin Common4.ynq(s); End;
Function  smci(c:char):string;
         Begin Smci := Common4.Smci(c); End;
Function  substone(src,old,new:string):string;
         Begin Substone := Common4.Substone(src,old,new); End;
Function  checkeventday(i:integer; t:real):boolean;
         Begin checkeventday := Common4.CheckEventDay(i,t); End;
Function  checkpreeventtime(i:integer; t:real):boolean;
         Begin CheckPreeventTime:= Common4.CheckPreEventTime(i,t); End;
Function  checkeventtime(i:integer; t:real):boolean;
         Begin CheckEventTime:= Common4.CheckEventTime(i,t); End;
Function  checkevents(t:real):integer;
         Begin CheckEvents:= Common4.CheckEvents(t); End;
Procedure doeventstuff;
          Begin Common4.DoEventStuff End;
Function  aonoff(b:boolean; s1,s2:string):string;
         Begin AoNoff:= Common4.AoNoff(b,s1,s2); End;
Function  onoff(b:boolean):string;
         Begin onoff:= common4.onoff(b); End;
Function  syn(b:boolean):string;
         Begin Syn:= Common4.Syn(b); End;
Procedure pyn(b:boolean);
          Begin Common4.Pyn(b); End;
Function  yn:boolean;
         Begin Yn:= Common4.Yn; End;
Function  pynq(s:string):boolean;
         Begin Pynq := Common4.Pynq(s); End;
Function  centre(s:string):string;
         Begin Centre := Common4.Centre(s); End;
Function  cstrl(li:longint):string;
         Begin Cstrl:= Common4.Cstrl(li); End;
Function  cstrr(rl:real; base:integer):string;
         Begin Cstrr:= Common4.Cstrr(rl,base); End;
Procedure ShowVersion;
          Begin Common4.ShowVersion;  End;
Function  MakeLength(Len : Byte; Str : String) : String;
         Begin Makelength := Common4.Makelength(Len,Str); End;
Procedure lcmds(len,c:byte; c1,c2:string);
          Begin Common4.LCmds(len,c,c1,c2); End;
Procedure handlempcode(var ccc:char);
          Begin Common4.HandlEmpCode(ccc); End;
Function  stripcolor(o:string):string;
         Begin StripColor := Common4.StripColor(o); End;
Function  tch(s:string):string;
         Begin Tch := Common4.Tch(s); End;
Function  date:string;
         Begin Date := Common4.Date; End;
Function  time:string;
         Begin Time := Common4.Time; End;
Function  dat:string;
         Begin Dat := Common4.Dat; End;
Procedure sde; { restore curco colors (DOS and tc) loc. after local }
          Begin Common4.Sde; End;
Procedure sdc; { restore curco colors (DOS and tc) loc/rem after loc/rem }
          Begin Common4.Sdc; End;
Procedure cl(c:integer);
          Begin Common4.Cl(c); End;
Procedure outtrap(c:char);
          Begin Common4.OutTrap(c); End;
Function  exist(fn:string):boolean;
         Begin Exist := Common4.Exist(fn); End;
Procedure InputPre(Var Str: String;Len : Integer);
          Begin Common3.InputPre(Str,Len); End;
procedure inputpassword(var s : string;len: integer);
          Begin Common3.InputPassword(S,Len); End;
Function  StripCH(Ch : Char; Str : String) : String;
         Begin StripCh := Common4.Stripch(ch,Str); End;
Function  AddSlash(S: String) : String;
         Begin AddSlash := Common4.AddSlash(s); End;
Function  StripSpaceEnd(Str: string) : string;
         Begin StripSpaceEnd := Common4.StripSpaceEnd(Str); End;
Procedure UserOnOtherNodes;
         Begin Common5.UserOnOtherNodes; End;
Function IsUserOn(N : Byte;Name:String): Boolean;
         Begin IsUserOn := Common5.IsUserOn(N,Name) End;
procedure dely(r:real);
          Begin common5.dely(r); end;
(*****************************************************************************)


var cfilter:cfilterrec;
    cfiltertype,cfilternum,cfiltercount:integer;


Procedure LoopLock(Var FHandle : File);
Var
 I : word;
 Done : Boolean;
Begin
 Done := False;
 I := 0;
 Repeat
   Delay(500);
   Inc(I);
   {$I-} Reset(FHandle); {$I+}

   If ((IoResult <> 0) and (I >= 10) and (UserOn)) then
    Begin
      Done := PynQ('File locked, try again? [y/N] ');
    End else
   If ((IoResult <> 0) and (I >= 10)) then
     Done := TRUE;

 Until (Done);
End;

function cstr(i:longint):string;   { Convert LongInt to String }
var c:string[16];
begin
  str(i,c);
  cstr:=c;
end;

function Allcaps(s:string):string;
var i:integer;
begin
  for i:=1 to length(s) do s[i]:=UpCaseMac(s[i]);
  allcaps:=s;
end;

function value(s:string):longint;
var i:longint;
    j:integer;
begin
  val(s,i,j);
  if (j<>0) then begin
    s:=copy(s,1,j-1);
    val(s,i,j)
  end;
  value:=i;
  if (s='') then value:=0;
end;


                   { UseBat?    CommandLine   RetCode }
Procedure shelldos(bat:boolean; cl:string; var rcode:integer);
{*************************************************************************}
{****** You must have 286 code generation turned on for this TO WORK!! ***}
{****** It is only for the ShellDos() Procedure , EXECSWAP requires it! ***}
{*************************************************************************}
var t:text;
    s:string;
    i:integer;
    speed : longint;
    emsswap:boolean;
Begin
  nosound;
  if (bat) then Begin
    assign(t,'bbstemp.bat'); rewrite(t);
    writeln(t,cl);
    close(t);
    cl:='bbstemp.bat';
  End;
  if (cl<>'') then cl:='/c '+cl;    { if '', just a local shell to DOS }

  s:=^M^J+#27+'[0m';
  for i:=1 to length(s) do dosansi(s[i]);

  remove_port;

  emsswap:=FALSE;

  if (systat.swapshell) then
    if (initexecswap2(heapptr,systat.swappath+'BBSSWAP.$$$')) then
    emsswap:=TRUE;

  swapvectors;
  if (not emsswap) then
  begin
     writeln('RUNNING :',getenv('COMSPEC'),cl);
     exec(getenv('COMSPEC'),cl);
     writeln('DOSERROR=',DOSERROR);
     delay(5000);
  end else
 Begin
  if (execwithswap2(getenv('COMSPEC'),cl)<>0) then
    Begin
      writeln('Cannot swap, performing normal execution');
      exec(getenv('COMSPEC'),cl);
    end else
     begin
       shutdownexecswap2;
     end;
 End;
  swapvectors;

  rcode:=lo(dosexitcode);
  if (bat) then Begin
    assign(t,'bbstemp.bat');
    {$I-} erase(t); {$I+}
    if (ioresult<>0) then ;
  End;
  if (spd='KB') then speed:=systat.waitbaud else speed:=value(spd);
  iport;
   InitFossil(systat.comport,Speed);
  { openport(systat.comport,speed,'N',8,1); }
End;

Procedure DisableInterrupts;
Begin
  inline($FA);  {cli}
End;

Procedure EnableInterrupts;
Begin
  inline($FB);  {sti}
End;

Procedure autovalidate(var u:userrec; un:integer);
var settings:set of uflags;
    b:boolean;
Begin
  settings:=[rlogon,rchat,rvalidate,rbackspace,ramsg,rpostan,rpost,remail,
             rXXX,rXXXX,fnodlratio,fnopostratio,fnofilepts,fnodeletion];
  with u do
  Begin
    if (un=usernum) then
    Begin
      realsl:=sl; realdsl:=dsl;
      newcomptables;
    End;

    sl:=systat.autosl; dsl:=systat.autodsl;
    ac:=ac-settings;
    ac:=ac+(systat.autoac*settings);
      (* do NOT modify user's personal settings, such as ANSI, color, etc.. *)
    ar:=systat.autoar;
    tltoday:=systat.timeallow[sl];
  End;

  if (un=usernum) then
  Begin
    realsl:=u.sl; realdsl:=u.dsl;   { bug fix msw}
  end;

  ssm(UN,^G'You were validated on '+date+' '+time+'.'^G);
  SaveUserNum(U,Un);
End;

Procedure SaveUserNum(user : UserRec; UserNumber : Longint);
Begin
 { assign(uf,systat.gfilepath+'user.lst'); }
  If (filerec(uf).mode<>fmclosed) then
      reset(uf);
{$I-} seek(UF,UserNumber);{$I+}
 If (IOResult = 0) then
     write(uf,User);

   { close(uf);}
End;


Function  timer:real;
var r:registers;
    h,m,s,t:real;
Begin
  r.ax:=44*256;
  msdos(dos.registers(r));
  h:=(r.cx div 256); m:=(r.cx mod 256); s:=(r.dx div 256); t:=(r.dx mod 256);
  timer:=h*3600+m*60+s+t/100;
End;

Function  ccinkey1:char;
var tar:array[1..20] of char;
    rl:real;
    tarc:integer;
    c:char;
Begin
  if (recom1(c)) then Begin
    ccinkey1:=c;  (* Not MiniTerm *)
    if ((c=^A))   (* and (not trm)) *)    then Begin
      tarc:=1; tar[1]:=^B;
      rl:=timer;
      repeat
        if (recom1(c)) then Begin tar[tarc]:=c; inc(tarc); End;
      until ((timer-rl>2.0) or (tarc>11) or (tar[1]<>^B));
      if (tarc>11) then Begin
        mpcoder:=(tar[1]+tar[2]+tar[9]+tar[10]+tar[11]=^B^A+#253+#254+#255);
        if (mpcoder) then
        Begin
          for tarc:=1 to 6 do mpcode[tarc]:=ord(tar[tarc+2]);
          handlempcode(c); ccinkey1:=#0;
        End;
      End;
    End;
  end else
    ccinkey1:=#0;
End;

Function  intime(tim:real; tim1,tim2:integer):boolean;
(* "tim" is seconds (timer) time; tim1/tim2 are minutes time. *)
Begin
  intime:=TRUE;
  while (tim>=24.0*60.0*60.0) do tim:=tim-24.0*60.0*60.0;
  if (tim1<>tim2) then
    if (tim2>tim1) then
      if (tim<=tim1*60.0) or (tim>=tim2*60.0) then
        intime:=FALSE
      else
    else
      if (tim<=tim1*60.0) and (tim>=tim2*60.0) then
        intime:=FALSE;
End;



Function  days(mo,yr:integer):integer;
var d:integer;
Begin
  d:=value(copy('312831303130313130313031',1+(mo-1)*2,2));
  if ((mo=2) and (leapyear(yr))) then inc(d);
  days:=d;
End;

Function  daycount(mo,yr:integer):integer;
var m,t:integer;
Begin
  t:=0;
  for m:=1 to (mo-1) do t:=t+days(m,yr);
  daycount:=t;
End;

Function  daynum(dt:string):integer;
var d,m,y,t,c:integer;
Begin
  t:=0;
  m:=value(copy(dt,1,2));
  d:=value(copy(dt,4,2));
  y:=value(copy(dt,7,2))+1900;
  for c:=1985 to y-1 do
    if (leapyear(c)) then inc(t,366) else inc(t,365);
  t:=t+daycount(m,y)+(d-1);
  daynum:=t;
  if y<1985 then daynum:=0;
End;


Procedure pr1(s:string);
var i:integer;
Begin
  for i:=1 to length(s) do sendcom1(s[i]);
End;

Procedure pr(s:string);
Begin
  pr1(s+#13);
End;


Function  getc(c:byte):string;
const xclr:array[0..7] of char=('0','4','2','6','1','5','3','7');
var s:string;
    b:boolean;

  Procedure adto(ss:string);
  Begin
    if (s[length(s)]<>';') and (s[length(s)]<>'[') then s:=s+';';
    s:=s+ss; b:=TRUE;
  End;

Begin
  b:=FALSE;
  if ((curco and (not c)) and $88)<>0 then Begin
    s:=#27+'[0';
    curco:=$07;
  end else
    s:=#27+'[';
  if (c and 7<>curco and 7) then adto('3'+xclr[c and 7]);
  if (c and $70<>curco and $70) then adto('4'+xclr[(c shr 4) and 7]);
  if (c and 128<>0) then adto('5');
  if (c and 8<>0) then adto('1');
  if (not b) then adto('3'+xclr[c and 7]);
  s:=s+'m';
  getc:=s;
End;

Procedure omtcolor(c:byte);
const color:array[0..15] of byte=($00,$04,$02,$06,$01,$05,$03,$07,
                                  $08,$0C,$0A,$0E,$09,$0D,$0B,$0F);
var c1:byte;
Begin
  if (mtcolors) then Begin
    if (c and $70=0) then pr1(^T+chr(c or $70)) else pr1(^T+'C'+chr(c));
  end else Begin
    if (thisuser.avadjust=2) then
    Begin
      c1:=color[c and $0F]+(color[(c and $70) shr 4] shl 4);
      if (c and $80<>0) then c1:=c1 or $80;
      pr1(^V^A+chr(c1));
    end else pr1(^V^A+chr(c and $7F));
    if (c and $80<>0) then pr1(^V^B);
  End;
End;

Procedure setc(c:byte);
var s:string;
    i:integer;
Begin
  if ((c<>curco) or (dosansion)) then
  Begin
    s:=getc(c); curco:=c;
    if (okansi) then Begin
      if (outcom) then
        if ((okavatar) or (mtcolors)) then omtcolor(c) else pr1(s);
      if (wantout) then
      Begin
        textattr:=c;
        if (dosansion) then
        Begin
          s:=#27+'[0;'+copy(s,3,length(s)-2);
          for i:=1 to length(s) do dosansi(s[i]);
        End;
      End;
    End;
    scc;
  End;
End;

Function  sqoutsp(s:string):string;
Begin
  while (pos(' ',s)>0) do delete(s,pos(' ',s),1);
  sqoutsp:=s;
End;

Function  mlnnomci(s:string; l:integer):string;
Begin
  while (length(s)<l) do s:=s+' ';
  if (length(s)>l) then
    repeat
     s:=copy(s,1,length(s)-1)
    until (length(s)=l) or (length(s)=0);
  mlnnomci:=s;
End;

Function  mlnmci(s:string; l:integer):string;
Begin
  while (lennmci(s)<l) do s:=s+' ';
  if (lennmci(s)>l) then
    repeat s:=copy(s,1,length(s)-1) until (lennmci(s)=l) or (length(s)=0);
  mlnmci:=s;
End;

Function  mln(s:string; l:integer):string;
Begin
  while (lenn(StripColor(s))<l) do s:=s+' ';
  if (lenn(StripColor(s))>l) then
    repeat
      s:=copy(s,1,length(s)-1)
    until (lenn(s)=l) or (length(s)=0);
  mln:=s;
End;

Function  mrn(s:string; l:integer):string;
Begin
  while lenn(s)<l do s:=' '+s;
  if lenn(s)>l then s:=copy(s,1,l);
  mrn:=s;
End;

Function  mn(i,l:longint):string;
Begin
  mn:=mln(cstr(i),l);
End;

Procedure dosansi(c:char);    { Do local ANSI sequences }
                              { PINGANSI emulator!      }
Begin
  WriteCharAnsi(C);
  {  AnsiWrite(C); }
End;


Procedure lpromptc(c:char);
var ss:string;
    bb:byte;
Begin
  if (c=^G) then exit;
  case c of
    ^H:if (pap>0) then dec(pap);
    ^J:Begin
         if ((not ch) {and (not write_msg) and (not reading_a_msg)} ) then
           if ((not ctrljoff) and (not dosansion)) then Begin
             bb:=thisuser.cols[color in thisuser.ac][1];
             if ((outcom) and (okansi)) then
               if ((okavatar) or (mtcolors)) then omtcolor(bb) else pr1(getc(bb));
             curco:=bb; textattr:=bb;
           end else
             lil:=0;
         if (wantout) then write(^J);
         inc(lil);
         if (lil>=thisuser.pagelen-1) then Begin
           lil:=0;
           if (pause in thisuser.ac) then pausescr;
         End;
         exit;
       End;
    ^L:lil:=0;
    ^M:pap:=0;
    ^[:dosansion:=TRUE;
  End;
   if (wantout) then if (not dosansion) then write(c) else dosansi(c);
End;

Procedure prompt(s:string);
var s1,s2:string;
    i:integer;
    bb:byte;
Begin
  checkhangup;
  if (hangup) then exit;
  if (outcom) then
  Begin
    s1:=s;
    while (pos(^J,s1)<>0) do
    Begin
      i:=pos(^J,s1);
      s2:=copy(s,1,i-1); s1:=copy(s1,i+1,length(s1)-i);
      for i:=1 to length(s2) do sendcom1(s2[i]);
      if ((not ch) {and (not write_msg) and (not reading_a_msg)} ) then
        if (not ctrljoff) then Begin
          bb:=thisuser.cols[color in thisuser.ac][1];
          if (okansi) then
            if ((okavatar) or (mtcolors)) then
              omtcolor(bb) else
               pr1(getc(bb));
          curco:=bb;
        end else
          lil:=0;
      sendcom1(^J);
    End;
    for i:=1 to length(s1) do sendcom1(s1[i]);
  End;
  for i:=1 to length(s) do lpromptc(s[i]);
  if (trapping) then
    if (copy(s,length(s)-1,2)=^M^J) then
      writeln(trapfile,copy(s,1,length(s)-2))
    else
      write(trapfile,s);
End;

Procedure print(s:string);
Begin
  prompt(s+^M^J);
End;

Procedure nl;
Begin
  prompt(^M^J);
End;

Procedure prt(s:string);
Begin
  cl(4); sprompt(s); cl(3);
End;

Procedure mpl(c:integer);
var i,x:integer;
Begin
  if (okansi) then Begin
    cl(6);
    x:=wherex;
    if (outcom) then for i:=1 to c do sendcom1(' ');
    if (wantout) then for i:=1 to c do write(' ');
    gotoxy(x,wherey);
    if (outcom) then Begin
      if (okavatar) then pr1(^Y+^H+chr(c)) else pr1(#27+'['+cstr(c)+'D');
    End;
  End;
  dec(pap,c);
End;

Procedure sprompt(s:string);
var ss,sss:string;
    i,p1,p2,x,z:integer;
    c,mc:char;
    xx,b:boolean;
Begin
  checkhangup;
  if (hangup) then exit;
  ss:=s; sss:='';
  b:=FALSE;
  if (pos('@',ss)<>0) then
  Begin
    for c:='A' to 'Z' do
      while (pos('@'+c,allcaps(ss))<>0) do
      Begin
        ss:=substone(ss,'@'+c,smci(c));
        b:=TRUE;
      End;
    while ((pos('@',ss)<>0) and (b)) do
    Begin
      for c:='A' to 'Z' do
        while (pos('@'+c,allcaps(ss))<>0) do
        ss:=substone(ss,'@'+c,smci(c));
      for i:=1 to length(ss)-1 do
        if ((ss[i]='@') and (not (ss[i+1] in ['A'..'Z']))) then
					ss[i]:=#28;
			if (ss[length(ss)]='@') then ss[length(ss)]:=#28;
    End;
    for i:=1 to length(ss) do
			if (ss[i]=#28) then ss[i]:='@';
  End;

  if (trapping) then write(trapfile,ss);
  if (not okansi) then
    ss:=stripcolor(ss)
  else
    while (ss<>'') and ((pos(#3,ss)<>0) or (pos('^',ss)<>0)) do Begin
      p1:=pos(#3,ss);  if (p1=0) then p1:=500;
      p2:=pos('^',ss); if (p2=0) then p2:=500;

      if (p2<p1) then p1:=p2;

      if (p1<>500) then
      Begin
        mc:=ss[p1+1]; sss:=copy(ss,1,p1-1);
        ss:=copy(ss,p1+2,length(ss)-(p1+1));
      end else
      Begin
        sss:=ss; ss:='';
      End;

      if (outcom) then
        Begin
        for i:=1 to length(sss) do
        Begin
            sendcom1(sss[i]);
            lpromptc(sss[i]);
        End;
        end else                { No external caller }
        for i:=1 to length(sss) do
            lpromptc(sss[i]);

      if ((mc>=#0) and (mc<=#9)) then cl(ord(mc)) else
        if ((mc>='0') and (mc<='9')) then
         cl(ord(mc)-48);

    {**** ADD @E SUPPORT *}

    End;
  if (outcom) then
    for i:=1 to length(ss) do sendcom1(ss[i]);
  for i:=1 to length(ss) do lpromptc(ss[i]);
End;

Procedure sprint(s:string);
Begin
  sprompt(s+'@M');
End;

Procedure prestrict(u:userrec);
var r:uflags;
Begin
  for r:=rlogon to rXXXX do
    if (r in u.ac) then write(copy('LCVBA*PEKM',ord(r)+1,1)) else write('-');
  writeln;
End;

Function  empty:boolean;
var e:boolean;
Begin
  e:=(not keypressed);
  if ((incom) and (e)) then e:=(com_rx_empty);
  if (hangup) then Begin com_flush_rx; e:=TRUE; End;
  empty:=e;
End;

Function  inkey:char;
var c:char;
Begin
  c:=#0; inkey:=#0;
  checkhangup;
  if (keypressed) then
  Begin
    c:=readkey;
    if ((c=#0) and (keypressed)) then Begin
      c:=readkey;

      skey1(c);

      if (c=#68) then c:=#1 else c:=#0;
      if (buf<>'') then Begin
        c:=buf[1];
        buf:=copy(buf,2,length(buf)-1);
      End;
    End;
    inkey:=c;
  end else
    if (incom) then inkey:=ccinkey1;
End;


Procedure docc2(c:char);
var i:integer;
Begin
  case c of
    ^G:if (outcom) then for i:=1 to 4 do sendcom1(#0);
    ^J:Begin
         if (wantout) then write(^J);
         inc(pap);
       End;
    ^L:Begin
         if (wantout) then clrscr;
         lil:=0;
       End;
  End;
End;

Procedure outkey(c:char);
Begin
  if (c=#29) then exit;
  if (not echo) then
    if ((systat.localsec) and (c in [#32..#255])) then c:=fstring.echoc;
  if (c=#27) then dosansion:=TRUE;
  if (not (c in [^J,^L])) then
    if (not ((c=^G) and (incom))) then
      if ((c<>#0) and (not nopfile) and (wantout)) then
        if (not dosansion) then write(c) else dosansi(c);
  if ((not echo) and (c in [#32..#255])) then c:=fstring.echoc;
  if (outcom) then sendcom1(c);
  if (c<#32) then docc2(c);
End;


Procedure dm(i:string; var c:char);
Begin
  buf:=i;
  if (buf<>'') then
  Begin
    c:=buf[1];
    buf:=copy(buf,2,length(buf)-1);
  End;
End;


Procedure getkey(var c:char);
var dt,ddt:datetimerec;
    aphase,e:integer;
    abort,next,b,tf,t1,bufalready:boolean;
Begin
  lil:=0; 
  if (buf<>'') then
  Begin
    c:=buf[1];
    buf:=copy(buf,2,length(buf)-1);
  end else
  Begin
    if (not empty) then
    Begin
      if (ch) then c:=chinkey else c:=inkey;
    end else
    Begin
      getdatetime(tim);
      t1:=FALSE; tf:=FALSE;
      c:=#0;
      if (alert in thisuser.ac) then aphase:=1 else aphase:=0;
    while ((c=#0) and (not hangup)) do
      Begin
        if (aphase<>0) then
        Begin
          case aphase of
            1:Begin sound(1000); delay(35); End;
            2:Begin sound(1500); delay(40); End;
            3:Begin sound(1900); delay(45); End;
            4:Begin sound(2300); delay(50); End;
            5:Begin sound(3400); delay(55); End;
          End;
          aphase:=aphase mod 5+1;
        End;

        if (ch) then c:=chinkey else c:=inkey;
        getdatetime(dt);
        timediff(ddt,tim,dt);

         { This is where we check other nodes for stuff, and multi }
         { notes to users and stuff...                             }
        If (Systat.MultiNode) then
        Begin        { SEMA Stuff }
           DoSemaCommand;
        End;

        if (systat.timeout<>-1) and (dt2r(ddt)>systat.timeout*60) and
           (c=#0) and (not (LocalIoOnly)) then
         Begin
          nl; nl;
          printf('timedout');
          if (nofile) then
            print('Time out has occurred.  Log off time was at '+time+'.');
          nl; nl;
          hangup:=TRUE;
          sysoplog(#3#7+'!*!*! Time-out at '+time+' !*!*!');
        End;

   if (systat.timeoutbell<>-1) and  (dt2r(ddt)>systat.timeoutbell*60) and
        (not tf) and (c=#0) and (Not (LocalIoOnly)) then
        Begin
          tf:=TRUE;
          outkey(^G); delay(100); outkey(^G);
        End;
        checkhangup;
      End;
      nosound;
    End;
  End;
  if (checkit) then
    if (ord(c) and 128>0) then checkit:=FALSE;
  if (c<#32) then skey(c);
End;


Procedure swac(var u:userrec; r:uflags);
Begin
  if (r in u.ac) then
    u.ac:=u.ac-[r] else u.ac:=u.ac+[r];
End;

Function  tacch(c:char):uflags;
Begin
  case c of
    'L':tacch:=rlogon;
    'C':tacch:=rchat;
    'V':tacch:=rvalidate;
    'B':tacch:=rbackspace;
    'A':tacch:=ramsg;
    '*':tacch:=rpostan;
    'P':tacch:=rpost;
    'E':tacch:=remail;
    'K':tacch:=rXXX;
    'M':tacch:=rXXXX;
    '1':tacch:=fnodlratio;
    '2':tacch:=fnopostratio;
    '3':tacch:=fnofilepts;
    '4':tacch:=fnodeletion;
  End;
End;

Procedure acch(c:char; var u:userrec);
Begin
  swac(u,tacch(c));
End;


Procedure onek(var c:char; ch:string);
var s:string;
Begin
  repeat
    if (not (onekey in thisuser.ac)) then Begin
      input(s,3);
      if length(s)>=1 then c:=s[1] else
        if (s='') and (pos(^M,ch)<>0) then c:=^M else
          c:=' ';
    end else Begin
      getkey(c);
      c:=upcase(c);
    End;
  until (pos(c,ch)>0) or (hangup);
  if (hangup) then c:=ch[1];
  if (onekey in thisuser.ac) then Begin
    if (onekda) then
      if (c in [#13,#32..#255]) then Begin
        outkey(c);
        if (trapping) then write(trapfile,c);
      End;
    if (onekcr) then nl;
  End;
  onekcr:=TRUE;
  onekda:=TRUE;
End;

Procedure wkey(var abort,next:boolean);
var c:char;
Begin
  if (empty) then exit;
  if ((abort) or (hangup)) then exit;

  getkey(c);
    c:= upcase(c);
    case c of
    ' ',^C,^X,^K:abort:=TRUE;
          'N',^N:Begin abort:=TRUE; next:=TRUE; End;
          'P',^S:getkey(c);
          else Begin
                iF ((pos(c,CmdList) <> 0) and (OneKey in ThisUser.Ac)) then
                       if Not (c in ['/',',','?']) then
                    Begin
                        HotKeyHit := c;
                        Abort :=TRUE;
                   End;
                End;
  End;   { Case }
  if (not allowabort) then
     Begin abort:=FALSE; next:=FALSE; End;
  if (abort) then
     Begin
       com_purge_tx;
       nl;
    if (HotKeyHit = #0)
        then sprint(#3#7+'Aborted.');
     End;
End;

Function  ctim(rl:real):string;
var h,m,s:string;
Begin
  s:=tch(cstr(trunc(rl-int(rl/60.0)*60.0)));
  m:=tch(cstr(trunc(int(rl/60.0)-int(rl/3600.0)*60.0)));
  h:=cstr(trunc(rl/3600.0));
  if (length(h)=1) then h:='0'+h;
  ctim:=h+':'+m+':'+s;
End;

Function  tlef:string;
Begin
  tlef:=ctim(nsl);
End;

Function  longtim(dt:datetimerec):string;
var s:string;
    d:integer;

  Procedure ads(comma:boolean; i:integer; lab:string);
  Begin
    if (i<>0) then Begin
      s:=s+cstrl(i)+' '+lab;
      if (i<>1) then s:=s+'s';
      if (comma) then s:=s+', ';
    End;
  End;

Begin
  s:='';
  with dt do Begin
    d:=day;
    if (d>=7) then Begin
      ads(TRUE,d div 7,'week');
      d:=d mod 7;
    End;
    ads(TRUE,d,'day');
    ads(TRUE,hour,'hour');
    ads(TRUE,min,'minute');
    ads(FALSE,sec,'second');
  End;
  if (s='') then s:='0 seconds';
  if (copy(s,length(s)-1,2)=', ') then s:=copy(s,1,length(s)-2);
  longtim:=s;
End;

Function  dt2r(dt:datetimerec):real;
Begin
  with dt do
    dt2r:=day*86400.0+hour*3600.0+min*60.0+sec;
End;

Procedure r2dt(r:real; var dt:datetimerec);
Begin
  with dt do Begin
    day:=trunc(r/86400.0); r:=r-(day*86400.0);
    hour:=trunc(r/3600.0); r:=r-(hour*3600.0);
    min:=trunc(r/60.0); r:=r-(min*60.0);
    sec:=trunc(r);
  End;
End;

Procedure timediff(var dt:datetimerec; dt1,dt2:datetimerec);
Begin
  with dt do Begin
    day:=dt2.day-dt1.day;
    hour:=dt2.hour-dt1.hour;
    min:=dt2.min-dt1.min;
    sec:=dt2.sec-dt1.sec;

    if (hour<0) then Begin inc(hour,24); dec(day); End;
    if (min<0) then Begin inc(min,60); dec(hour); End;
    if (sec<0) then Begin inc(sec,60); dec(min); End;
  End;
End;

Procedure getdatetime(var dt:datetimerec);
var w1,w2,w3,w4:word;
Begin
  gettime(w1,w2,w3,w4);
  with dt do Begin
    day:=daynum(date);
    hour:=w1;
    min:=w2;
    sec:=w3;
  End;
End;

Procedure loadcfilter(s:string);
var cfilterf:file of cfilterrec;
    os,ps,ns,es:string;
    i:integer;
Begin
  if ((not printingfile) or (not okansi)) then exit;
  os:=s;
  if (copy(s,1,1)<>'*') then Begin
    if (not exist(s)) then Begin
      fsplit(s,ps,ns,es);
      if (exist(systat.afilepath+ns+es)) then s:=systat.afilepath+ns+es
      else
      if (exist(systat.gfilepath+ns+es)) then s:=systat.gfilepath+ns+es;
    End;
    assign(cfilterf,s);
    {$I-} reset(cfilterf); {$I+}
    if (ioresult=0) then Begin
      {$I-} read(cfilterf,cfilter); {$I+}
      if (ioresult=0) then Begin
        if (not mtcolors) then Begin
          cfilteron:=TRUE;
          cfiltertype:=0;
        end else Begin
          pr1(^T+'c=');
          for i:=0 to 255 do sendcom1(chr(cfilter[i]));
          pr1(';');
          mtcfilteron:=TRUE; cfilteron:=TRUE;
          cfiltertype:=0;
        End;
      End;
      close(cfilterf);
    end else
      sysoplog('Missing color filter: '+os);
  end else Begin
    if (length(s)<3) then exit;
    case upcase(s[2]) of
      'C':cfiltertype:=1;
      'R':cfiltertype:=2;
    End;
    s:=copy(s,3,length(s)-2);
    cfilternum:=0;
    while (pos(',',s)<>0) do Begin
      cfilter[cfilternum]:=value(s); inc(cfilternum);
      s:=copy(s,pos(',',s)+1,length(s)-pos(',',s));
    End;
    cfilter[cfilternum]:=value(s); inc(cfilternum);
    cfilteron:=TRUE; cfiltercount:=0;
  End;
End;

Procedure printa1(s:string; var abort,next:boolean);
var s1,s2,ss,sss,ssss,tcode,mcix,sysmcixx,mcixx:string;
    i,ls,p1,p2,p3:integer;
    c,mc:char;
    savcurco:byte;
    isansi,iscolor,ismci,istcode,usetcodes:boolean;

  Function  nmci(c:char):string;
  Begin
    nmci:='';
    case c of
      '1':nmci:=thisuser.name;
      '2':nmci:=thisuser.realname;
      '3':nmci:=thisuser.ph;
      '4':nmci:=thisuser.citystate;
      '5':nmci:=thisuser.street;
      '6':nmci:=thisuser.zipcode;
      '!':if (printingfile) then allowabort:=FALSE;
      '#':thisuser.ac:=thisuser.ac-[pause];
    End;
  End;

  Function  SysNMci(c:char):string;
  var s2s : string;
  Begin
    case c of
      'B':if spd ='KB' then s2s :='Local' { BPS RATE }
          else s2s := spd;
      'C':S2s:=Cstr(Systat.CallerNum);
      'D':S2s:=Date;                     { system date }
      'N':S2s:=Cstr(Node);
      'T':S2s:=Time;                     { system time }

    End;
    SysNMci := s2s;
  End;

  Procedure domci(c:char);
  Begin
    case c of
      '7':cls;
      '8':delay(800);
      '9':pausescr;
    End;
  End;

  Procedure dotcode(c:char; var s:string);
  var s1,s2:string;
  Begin
    case mc of
      'c':if (pos(';',s)<>0) then
          Begin
            s1:=copy(s,1,pos(';',s)-1);
            delete(s,1,length(s1)+1);
            loadcfilter(s1);
          End;
      'C':Begin
            if (okansi) then setc(ord(s[1]));
            delete(s,1,1);
          End;

    End;
  End;

  Procedure sends(s:string);
  var i:word;
  Begin
    i:=0;
    while (i<length(s)) do
    Begin
      inc(i);
      sendcom1(s[i]);
    End;
  End;

  Procedure sendscfilter(s:string);
  var i:integer;
      bb:byte;
  Begin
    i:=1;
    savcurco:=curco;
    while (i<=length(s)) do
    Begin
      case cfiltertype of
        0:bb:=cfilter[ord(s[i])];
        1:Begin
            cfiltercount:=cfiltercount mod cfilternum+1;
            bb:=cfilter[cfiltercount-1];
          End;
        2:bb:=cfilter[random(cfilternum)];
      End;
      if (bb<>curco) then Begin
        if ((okavatar) or (mtcolors)) then omtcolor(bb) else pr1(getc(bb));
        curco:=bb;
      End;
      sendcom1(s[i]);
      inc(i);
    End;
    curco:=savcurco;
  End;

  Procedure locs(s:string);
  var i:integer;
  Begin
    i:=0;
    while (i<length(s)) do
    Begin
      inc(i);
      lpromptc(s[i]);
    End;
  End;

  Procedure locscfilter(s:string);
  var i:integer;
      bb:byte;
  Begin
    i:=1;
    while (i<=length(s)) do Begin
      case cfiltertype of
        0:bb:=cfilter[ord(s[i])];
        1:Begin
            cfiltercount:=cfiltercount mod cfilternum+1;
            bb:=cfilter[cfiltercount-1];
          End;
        2:bb:=cfilter[random(cfilternum)];
      End;
      if (bb<>curco) then Begin textattr:=bb; curco:=bb; End;
      lpromptc(s[i]);
      inc(i);
    End;
  End;


  Procedure handlecolors;
  Begin

  repeat
    mc:=ss[p1+1]; sss:=copy(ss,1,p1-1);
    ss:=copy(ss,p1+2,length(ss)-(p1+1));

    if (outcom) then sends(sss);
    locs(sss);

    if ((mc>=#0) and (mc<=#9)) then cl(ord(mc)) else
      if ((mc>='0') and (mc<='9')) then cl(ord(mc)-48);

    p1:=pos(#3,ss);
   until (p1=0);
  End;

  Procedure handletcodes;
  Begin
   repeat
    if ((p3<p2) and (p3<>0)) then
    Begin
      istcode:=TRUE;
      p2:=p3;
    end else
      istcode:=FALSE;
    mc:=ss[p2+1]; sss:=copy(ss,1,p2-1);
    ss:=copy(ss,p2+2,length(ss)-(p2+1));
    if (outcom) then sends(sss);
                     locs(sss);
    if (Not Istcode) then
        domci(mc) else dotcode(mc,ss);
    p2:=pos('@',ss); p3:=pos(^T,ss);
  until (p2+p3<=0);
 End;

  Procedure handletcodesc;
  Begin
 repeat
    if (p2<>500) then
      if (pos(ss[p2+1],mcixx)=0) then p2:=500;

    iscolor:=TRUE; istcode:=FALSE;
    if ((p2<p1) or (p3<p1)) then
      if ((p2<p1) and (p2<p3)) then Begin p1:=p2; iscolor:=FALSE; end else
        if (p3<p1) then Begin p1:=p3; iscolor:=FALSE; istcode:=TRUE; End;

    mc:=ss[p1+1]; sss:=copy(ss,1,p1-1);
    ss:=copy(ss,p1+2,length(ss)-(p1+1));

    if (outcom) then sends(sss);
    locs(sss);

    if (iscolor) then
    Begin
      if ((mc>=#0) and (mc<=#9)) then cl(ord(mc)) else
        if ((mc>='0') and (mc<='9')) then cl(ord(mc)-48);
    end else
      if (not istcode) then domci(mc) else
                            dotcode(mc,ss);

    p1:=pos(#3,ss);  if (p1=0) then p1:=500;
    p2:=pos('@',ss); if (p2=0) then p2:=500;
    p3:=pos(^T,ss);  if (p3=0) then p3:=500;
 until (p1+p2+p3>=1500);
End;

Begin
  tcode:=''; ss:='';
  if (abort) then exit;
  doit:=TRUE; isansi:=FALSE;
  if (pos(^[,s)<>0) then Begin
    lil:=0;
    isansi:=TRUE;
  end else
    if (s[1]='&') then Begin
      if (thisuser.sl<value(copy(s,2,4))) then doit:=FALSE;
      s:=copy(s,5,length(s)-4);
    End;
  if ((hangup) or (not doit)) then Begin abort:=TRUE; exit; End;
  ss:=s; sss:=''; i:=1;

  mcix:='123456!#';
 {^^^^^^^^^^^^^   Codes for the Current user }

  mcixx:='789';
 {^^^^^^^^^^^^^^^        Codes for System no insert info (pause ect) Info }

  Sysmcixx:='BCDNT';
{ ^^^^^^^^^^^^^^^^^^^^ Codes for system info  }

    if (pos('@',ss)<>0) then
      for i:=1 to 8 do
      Begin
        c:=mcix[i];
        while (pos('@'+c,ss)<>0) do ss:=substone(ss,'@'+c,nmci(c));
      End;

    if (pos('@',ss)<>0) and (Not ReadingMail) then
      for i:=1 to Length(SysMciXX) do
      Begin
        c:=Sysmcixx[i];
        while (pos('@'+c,ss)<>0) do ss:=substone(ss,'@'+c,SysNmci(c));
      End;


  while (pos(#29,ss)<>0) do delete(ss,pos(#29,ss),1);
  if (not okansi) then
     ss:=stripcolor(ss);
  if (trapping) then
     write(trapfile,ss);

  if (not cfilteron) then
  Begin
    p1:=pos(#3,ss);  if (p1=0) then p1:=500;
    p2:=pos('@',ss); if (p2=0) then p2:=500;
    p3:=pos(^T,ss);  if (p3=0) then p3:=500;
    if (isansi) then
    Begin
      p1:=500; p2:=500; p3:=500;
    End;

(*
   Used to be if Not Read_Mci or reading Msg then....So the MCI codes were
   ignored.  Be sure to watch this in the future.
*)
    if ((ReadingMail) and (p2+p3<>1000)) then
      Begin
        p2:=500;  p3:=500;
      End;

    if ((p2=500) and (p3=500)) then
    Begin
      if (p1<>500) then handlecolors;
    end else
      if (p1=500) then handletcodes  else
                            handletcodesc;
    if (outcom) then sends(ss);
    locs(ss);
  end else
  Begin
    if (outcom) then if (mtcfilteron) then sends(ss) else sendscfilter(ss);
    locscfilter(ss);
    if (cfiltertype=0) then
      if ((cfilter[32] and 112)<>0) then
      Begin
        setc(cfilter[32]);
        if (okavatar) then pr1(^V+^G) else pr1(^['[K');
        clreol;
      End;
  End;
  wkey(abort,next);
End;

Procedure printacr(s:string; var abort,next:boolean);
var org:string;
    p,op,rp,rop,nca:integer;
    okdoit,sram,turnoff:boolean;

  Procedure doboxedtitle(s:string);
  const B_UL=''; B_UR=''; B_LL=''; B_LR='';
        B_TOP=''; B_BOT=''; B_LFT=''; B_RGT='';
  var b:array[0..7] of char;
      x,numsp:integer;
      i:string;

    Function  ritr(c:char; l:integer):string;
    var s:string;
        i:integer;
    Begin
      s:='';
      for i:=1 to l do s:=s+c;
      ritr:=s;
    End;

  Begin
    i:=s;
    if (i[length(i)]=#1) then i:=copy(i,1,length(i)-1);
    if (okansi) then
      for x:=0 to 7 do
        case x of
          0:b[x]:=B_UL;   1:b[x]:=B_UR;   2:b[x]:=B_LL;  3:b[x]:=B_LR;
          4:b[x]:=B_TOP;  5:b[x]:=B_BOT;  6:b[x]:=B_LFT; 7:b[x]:=B_RGT;
        end
    else
      for x:=0 to 7 do
        case x of
          0:b[x]:='.';  1:b[x]:='.';  2:b[x]:='`';  3:b[x]:='''';
          4:b[x]:='-';  5:b[x]:='-';  6:b[x]:=':';  7:b[x]:=':';
        End;
    numsp:=(thisuser.linelen div 2)-((lenn(i)+4) div 2);
    printacr(#3#4+ritr(#32,numsp)+b[0]+ritr(b[4],lenn(i)+2)+b[1],abort,next);
    printacr(#3#4+ritr(#32,numsp)+b[6]+' '+#3#3+i+#3#4+' '+b[7],abort,next);
    printacr(#3#4+ritr(#32,numsp)+b[2]+ritr(b[5],lenn(i)+2)+b[3]+#3#1,abort,next);
  End;

Begin
  if ((allowabort) and (abort)) then exit;
 
  if (s[length(s)]=#1) then
    if (copy(s,length(s)-1,1)<>#3) then s:=copy(s,1,length(s)-1);

  okdoit:=TRUE; abort:=FALSE; nopfile:=FALSE;
  turnoff:=(s[length(s)]=#29);

  if (copy(s,1,1)='&') then
  Begin
    if (thisuser.sl<value(copy(s,2,4))) then exit;
    s:=copy(s,5,length(s)-4);
  End;
  checkhangup;


  if (pos(^[,s)>0) then
  Begin
    printa1(s,abort,next);
    if ((not turnoff) and (not croff)) then
    Begin
      nl;
      if (trapping) then writeln(trapfile);
    End;
    croff:=FALSE;
    exit;
  end else
  if (s[1]=#2) then
  Begin
    printa1(centre(s),abort,next);
    if (not turnoff) then nl;
    croff:=FALSE; exit;
  end else
  if (length(s)>=3) and (copy(s,1,3)=BOXEDTITLE) then
  Begin
    doboxedtitle(copy(s,4,length(s)-3));
    croff:=FALSE; exit;
  end else Begin
    printa1(s,abort,next);
    if (abort) then
       Begin curco:=255-curco; cl(1); End;
    if ((not nofeed) and (doit) and (not croff) and (not turnoff)) then
      if (not abort) then nl;
    doit:=TRUE;
  End;
  croff:=FALSE;
End;

Procedure pfl(fn:string; var abort,next:boolean; cr:boolean);
var fil:text;
    ofn:string;
    ls:string[255];
    ps:integer;
    c:char;
    oldpause,oaa:boolean;
Begin
  cfilteron:=FALSE; cfiltertype:=0; cfilternum:=0; cfiltercount:=0;
  printingfile:=TRUE;
  oaa:=allowabort;
  allowabort:=TRUE;
  abort:=FALSE; next:=FALSE;

  oldpause:=(pause in thisuser.ac);
  nofile:=FALSE;

  if (not hangup) then
  Begin
    assign(fil,sqoutsp(fn));
    {$I-} reset(fil); {$I+}
    if (ioresult<>0) then nofile:=TRUE
    else
    Begin
      abort:=FALSE;
      while ((not eof(fil)) and (not nofile) and
             (not abort) and (not hangup)) do
             Begin
        ps:=0;
       repeat
          inc(ps);
          read(fil,ls[ps]);
        until ((ls[ps]=^M) or (ps=255) or (eof(fil)) or (hangup));
        ls[0]:=chr(ps);
        if (ls[ps]=^M) then
        Begin
          if (not eof(fil)) then read(fil,c);
          ls[0]:=chr(ps-1);
        end else
          croff:=TRUE;
        if (pos(^[,ls)<>0) then ctrljoff:=TRUE;
        printacr(ls,abort,next);
      End;
      close(fil);
    End;
  End;
  if (oldpause) then thisuser.ac:=thisuser.ac+[pause];
  allowabort:=oaa;
  if (mtcfilteron) then Begin pr1(^T'c-'); mtcfilteron:=FALSE; End;
  cfilteron:=FALSE; printingfile:=FALSE; ctrljoff:=FALSE;
  curco:=255-curco; cl(1);
  redrawforansi;
End;

Procedure printfile(fn:string);
var s:string;
    year,month,day,dayofweek:word;
    i,j:integer;
    abort,next:boolean;
Begin
  fn:=allcaps(fn); s:=fn;
  if (copy(fn,length(fn)-3,4)='.ANS') then Begin
    if (exist(copy(fn,1,length(fn)-4)+'.AN1')) then
      repeat
        i:=random(10);
        if (i=0) then
          fn:=copy(fn,1,length(fn)-4)+'.ANS'
        else
          fn:=copy(fn,1,length(fn)-4)+'.AN'+cstr(i);
      until (exist(fn));

    getdate(year,month,day,dayofweek);
    s:=fn; s[length(s)-1]:=chr(dayofweek+48);
    if (exist(s)) then fn:=s;
  End;
  pfl(fn,abort,next,TRUE);
End;

Procedure printf(fn:string);              { see if an *.ANS file is available }
var ffn,ps,ns,es:string;                  { if you have ansi graphics invoked }
    i,j:integer;
Begin
  nofile:=TRUE;
  fn:=sqoutsp(fn);
  if (fn='') then exit;
  if (pos('\',fn)<>0) then j:=1
  else Begin
    j:=2;
    fsplit(fexpand(fn),ps,ns,es);
    if (not exist(systat.afilepath+ns+'.*')) then
      if (not exist(systat.gfilepath+ns+'.*')) then exit;
  End;
  for i:=1 to j do Begin
    ffn:=fn;
    if ((pos('\',fn)=0) and (pos(':',fn)=0)) then
      case i of
        1:ffn:=systat.afilepath+ffn;
        2:ffn:=systat.gfilepath+ffn;
      End;
    ffn:=fexpand(ffn);
    if (pos('.',fn)<>0) then printfile(ffn)
    else Begin
      if ((okansi) and (not okavatar)) and (exist(ffn+'.ans')) then printfile(ffn+'.ans');
      if (nofile) then
        if (thisuser.linelen<80) and (exist(ffn+'.40c')) then
          printfile(ffn+'.40c')
        else
          if (exist(ffn+'.ASC')) then printfile(ffn+'.ASC');
    End;
    if (not nofile) then exit;
  End;
End;

Function  aacs1(u:userrec; un:integer; s:string):boolean;
var s1,s2:string;
    p1,p2,i,j:integer;
    c,c1,c2:char;
    b:boolean;

  Procedure getrest;
  Begin
    s1:=c;
    p1:=i;
    if ((i<>1) and (s[i-1]='!')) then Begin s1:='!'+s1; dec(p1); End;
    if (c in ['C','F','G','R','V','X']) then Begin
      s1:=s1+s[i+1];
      inc(i);
    end else Begin
      j:=i+1;
      repeat
        if (s[j] in ['0'..'9']) then
        Begin
          s1:=s1+s[j];
          inc(j);
        End;
      until ((j>length(s)) or (not (s[j] in ['0'..'9'])));
      i:=j-1;
    End;
    p2:=i;
  End;

  Function  argstat(s:string):boolean;  { This is the "SL255!D255" ect...}
  var vs:string;
      year,month,day,dayofweek,hour,minute,second,sec100:word;
      vsi:integer;
      boolstate,res:boolean;
  Begin
    boolstate:=(s[1]<>'!');
    if (not boolstate) then s:=copy(s,2,length(s)-1);
    vs:=copy(s,2,length(s)-1); vsi:=value(vs);
    case s[1] of
      'A':res:=(ageuser(u.bday)>=vsi);
      'B':res:=((value(spd)>=value(vs+'00')) or (spd='KB'));
      'D':res:=(u.dsl>=vsi);
      'F':res:=(upcase(vs[1]) in u.ar);
      'G':res:=(u.sex=upcase(vs[1]));
      'H':Begin
            gettime(hour,minute,second,sec100);
            res:=(hour=vsi);
          End;
      'P':res:=(u.filepoints>=vsi);
      'R':res:=(tacch(upcase(vs[1])) in u.ac);
      'S':res:=(u.sl>=vsi);
      'T':res:=(trunc(nsl) div 60>=vsi);
      'U':res:=(un=vsi);
      'V':res:=((u.sl>systat.newsl) or (u.dsl>systat.newdsl) or
           ((systat.newsl=systat.autosl) and (systat.newdsl=systat.autodsl)));
      'W':Begin
            getdate(year,month,day,dayofweek);
            res:=(dayofweek=ord(s[1])-48);
          End;
      'Y':res:=(trunc(timer) div 60>=vsi);
    End;
    if (not boolstate) then res:=not res;
    argstat:=res;
  End;

Begin
  s:=allcaps(s);
  i:=0;
  while (i<length(s)) do Begin
    inc(i);
    c:=s[i];
    if (c in ['A'..'Z']) and (i<>length(s)) then Begin
      getrest;
      b:=argstat(s1);
      delete(s,p1,length(s1));
      if (b) then s2:='^' else s2:='%';
      insert(s2,s,p1);
      dec(i,length(s1)-1);
    End;
  End;
  s:='('+s+')';
  while (pos('&',s)<>0) do delete(s,pos('&',s),1);
  while (pos('^^',s)<>0) do delete(s,pos('^^',s),1);
  while (pos('(',s)<>0) do Begin
    i:=1;
    while ((s[i]<>')') and (i<=length(s))) do Begin
      if (s[i]='(') then p1:=i;
      inc(i);
    End;
    p2:=i;
    s1:=copy(s,p1+1,(p2-p1)-1);
    while (pos('|',s1)<>0) do Begin
      i:=pos('|',s1);
      c1:=s1[i-1]; c2:=s1[i+1];
      s2:='%';
      if ((c1 in ['%','^']) and (c2 in ['%','^'])) then Begin
        if ((c1='^') or (c2='^')) then s2:='^';
        delete(s1,i-1,3);
        insert(s2,s1,i-1);
      end else
        delete(s1,i,1);
    End;
    while(pos('%%',s1)<>0) do delete(s1,pos('%%',s1),1);   {leave only "%"}
    while(pos('^^',s1)<>0) do delete(s1,pos('^^',s1),1);   {leave only "^"}
    while(pos('%^',s1)<>0) do delete(s1,pos('%^',s1)+1,1); {leave only "%"}
    while(pos('^%',s1)<>0) do delete(s1,pos('^%',s1),1);   {leave only "%"}
    delete(s,p1,(p2-p1)+1);
    insert(s1,s,p1);
  End;
  aacs1:=(not (pos('%',s)<>0));
End;

Function  aacs(s:string):boolean;
Begin
  aacs:=aacs1(thisuser,usernum,s);
End;

{ load account "i" if i<>usernum; else use "thisuser" account }
Procedure loadurec(var u:userrec; i:integer);
var ufo:boolean;
Begin
  ufo:=(filerec(uf).mode<>fmclosed);
  if (not ufo) then reset(uf);
  if (i<>usernum) AND (I<=FileSize(Uf)-1) then
  Begin
    Seek(uf,i);
    Read(uf,u);
  end else
    u:=thisuser;
  if (not ufo) then close(uf);
End;

{ save account "i" if i<>usernum; save data into "thisuser" account if same }
Procedure saveurec(u:userrec; i:integer);
var ufo:boolean;
Begin
  ufo:=(filerec(uf).mode<>fmclosed);
  if (not ufo) then reset(uf);
  seek(uf,i); write(uf,u);
  if (i=usernum) then thisuser:=u;
  if (not ufo) then close(uf);
End;


end.
