{ This CANNOT be overlayed due to the speed needed and other such things }
{}
{}

{$A+,B+,D-,E+,F+,I+,L+,N-,O-,R-,S+,V-}
Unit FilesAcc;
Interface
 Uses Common;

Const
  MSGBASE      = 0;
  SYSREAD      = 1;
  SYSWRITE     = 2;
  STRREAD      = 3;
  STRWRITE     = 4;
  MSGBASEREAD  = 5;
  MSGBASEWRITE = 6;
  ShadowList   = 1;
  StringList   = 2;
  UserList     = 3;
  UserOnList   = 4;
  ShadowRes    = 'SHADOW';
  StringRes    = 'STRING';
  UserRes      = 'USER';
  UserOnRes    = 'ONUSER';

Procedure Make_Sema_Txt(FileData : Byte);
Procedure LoadSystat(path : string);  { Load Shadow.DAT }
Procedure SaveSystat(path : String);  { Save Shadow.dat }
Procedure Load_String(path : String); { load string.dat }
Procedure Save_String(path : String); { save string.dat }
Procedure Updated_UserFile;
Procedure CheckNodeParams;
Procedure MakeNodeHere(N : Byte);
Procedure DelNodeHere(N : Byte);
Procedure MakeUserOn(U : UserRec);
Procedure DelUserOn;
Procedure SendNodeMessage(NodeToGet : Integer; StrTOSend : String);
Function LockFile(FileType : Byte; MsgFName : String) : Boolean;
Function CheckFile(FileType : Byte; MsgFName : String) : Boolean;

Implementation
Uses
   MyIo,OPCrt,OpString;


Procedure Make_Sema_Txt(FileData : Byte);

Var
  T : text;
  Fn: String;
  i : Word;
Begin
      Case FileData Of
        ShadowList: Fn := ShadowRES;
        StringList: Fn := StringRES;
        UserList  : Fn := UserRES;
        UserOnList: Fn := UserOnRES;
      End; { Case }

  I := 0;
  Repeat
    Inc(I);
    If (Exist(Systat.SemaPath+'UPNODE.'+Cstr(I))) AND (Node <> I) then
     Begin
      Assign(T,Systat.SemaPath+FN+'.'+Cstr(I));
      rewrite(t);
      Close(T);
     End;
  Until (i >=99);
End;

Procedure CheckNodeParams;
var
    d:String;
    a,count:integer;

  function sc(s:astr; i:integer):char;
  begin
    s:=allcaps(s); sc:=s[i];
  end;

  function atoi(s:astr):word;
  var i,code:integer;
  begin
    val(s,i,code);
    if code<>0 then i:=0;
    atoi:=i;
  end;

begin
  Node := 1; a:=0;

  while (a<paramcount) do
  begin
    inc(a);
    if ((sc(paramstr(a),1)='-') or (sc(paramstr(a),1)='/')) then
      case sc(paramstr(a),2) of
        'N':Node := Atoi(copy(paramstr(A),3,length(paramstr(a))-2));
      end;
  end;
end;

Procedure DelNodeHere(N : Byte);
Var
 T : text;

Begin
 assign(t,systat.semapath+'UPNODE.'+Cstr(Node));
 rewrite(T);
 writeln(T,'Node #',Node,' if Down!');
 Close(T);
 Erase(t);
End;

Procedure MakeNodeHere(N : Byte);
Var
 T : text;

Begin
 assign(t,systat.semapath+'UPNODE.'+Cstr(Node));
 rewrite(T);
 writeln(T,'Node #',Node,' if Up!');
 Close(T);
End;

Procedure LoadSystat(path : string);
Var
 Systatf : file of systatrec;
 Fn      : String;
Begin
  If (Node > 1) then
     Fn :='Shadow'+Cstr(Node)+'.DAT' else
     Fn :='SHADOW.DAT';
  assign(systatf,path+'\'+FN);
  {$I-} reset(systatf); {$I+}
  if (ioresult<>0) then
  begin
    TextColor(LightRed);
    writeln;
    writeln('Unable to find ',Fn,'.  This is the main control file for Shadow BBS');
    writeln('and is required.  You must run BBSINIT.EXE to create it.');
    if (exiterrors<>-1) then halt(exiterrors) else halt(254);
  end else
  begin
    {$I-} read(systatf,systat); {$I+}
    close(systatf);
  end;
End;

Procedure SaveSystat ( Path : String);
var systatf:file of systatrec;
begin
  assign(systatf,path+'\Shadow.dat');
  rewrite(systatf);
  write(systatf,systat);
  close(systatf);
  Make_Sema_TXT(ShadowList);
end;


Procedure Load_String(path : String);
var fstringf : file of fstringrec;
Begin
  assign(fstringf,path+'string.dat');
  reset(fstringf);
  seek(fstringf,0);
  CommandLine('-Loading STRING File-');
  read(fstringf,fstring);
  close(fstringf);
End;

Procedure Save_String(path : String);
var fstringf : file of fstringrec;
Begin
  assign(fstringf,path+'string.dat');
  reset(fstringf);
  seek(fstringf,0);
  write(fstringf,fstring);
  close(fstringf);
  Commandline('-Saving STRING.DAT-');
  Make_Sema_Txt(StringList);
End;

Procedure Updated_UserFile;
Begin
 CommandLine('Forcing USER.LST rescan on other nodes if needed.');
 Make_Sema_Txt(UserList);
End;

Procedure MakeUserOn(U : UserRec);
  Var
   UOnFile : File of OUserOnRecord;
   UO      : OUserOnRecord;
Begin
 assign(UOnFile,Systat.SemaPath+'USERON.'+Cstr(Node));
 rewrite(UONFile);
 Uo.ONodeOn := Node;
 UO.OName   := ThisUser.RealName;
 UO.OAlias  := ThisUser.Name;
 UO.ONUser  := UserNum;
 UO.UONStr   := '';
 write(UONFile,UO);
 Close(UONFile);
End;

Procedure DelUserOn;
  Var
   UOnFile : File of OUserOnRecord;
   UO      : OUserOnRecord;
Begin
 Assign(UOnFile,Systat.SemaPath+'USERON.'+Cstr(Node));
 {$i-} reset(UonFile); {$i+}
  If (IoResult = 0) then
   Begin
    Close(UOnFile);
    Erase(UOnFile);
   End;
End;

Function UserNumOn(UNum : Integer) : Boolean;
Var
 i       : integer;
 Done    : Boolean;
 UOnFile : File of OUserOnRecord;
 UO      : OUserOnRecord;

Begin
 Done := False;
 I := 0;
 repeat
  Inc(I);
  If (Exist(Systat.SemaPath+'USERON.'+Cstr(i)) And (I <> Node)) then
   Begin
    Assign(UOnFile,Systat.SemaPath+'USERON.'+Cstr(I));
    reset(UOnFile);   Read(UOnFile,Uo);
    Close(UonFile);
    If (UO.ONUser = UNum) then Done := TRUE;
   End;

 Until  (I >= 99) or (Done);

End;

Function UseronNode(UNumber : Integer) : Integer;
Var
   UOnFile : File of OUserOnRecord;
   UO      : OUserOnRecord;
   FoundUser,
   Done    : Boolean;
   NodeOn,
   I       : Word;

Begin
  Done := False;
  FoundUser := False;
  NodeOn := 0;
  I := 0;
  repeat
    Inc(I);
    If (Exist(Systat.SemaPath+'USERON.'+Cstr(I))) then
     Begin
      Assign(UonFile,Systat.SemaPath+'USERON.'+Cstr(I));
      reset(UonFile);
      read(UonFile,Uo);
      Close(UOnFile);
        writeln('Node #',i,'; On that node User #',UO.OnUser,'!!!!!!!!!!!');
        writeln('Trying to match #',UNumber);
        delay(1000);
      If (UO.ONUser = UNumber)  then
        Begin
         Done := TRUE;
         FoundUser := TRUE;
         NodeOn    := UO.ONodeOn;
        end;
     End;
     If (I >= 99) then Done := TRUE;
  Until (Done);

 If (FoundUser) then UserOnNode := NodeOn else
    UserOnNode := -1;
End;

Procedure SendNodeMessage(NodeToGet : Integer; StrTOSend : String);
  Var
   UOnFile : File of OUserOnRecord;
   UO      : OUserOnRecord;
   Done    : Boolean;
   I       : word;
Begin
   Assign(UOnFile,Systat.SemaPath+'USERON.'+Cstr(NodeToGet));
   {$I-} reset(UOnFile); {$I+}
    Case IoResult of
      0    :;
      2    :  Begin print('User left before note could be sent...'); Exit; End;
      5,162 : Begin
                 Done := False;
                 I := 0;
                 Repeat
                 Delay(500);
                 Inc(I);
                 {$I-} Reset(UonFile); {$I+}
                  If ((IoResult <> 0) and (I >= 10) and (UserOn)) then
                      Begin
                       Done := PynQ('File locked, try again? [y/N] ');
                       if (Done) then  I := 0;
                      End else
                 If ((IoResult <> 0) and (I >= 10)) then
                     Done := TRUE;
                   Until (Done);
                  End;
     End; { Case }

     Read(UonFile,Uo);    Uo.UonStr := StrToSend;
     Seek(UOnFile,0);     Write(Uonfile,UO);
    Close(UonFile);
    Make_Sema_Txt(UserOnList);
    SysOpLog(#3#5+ThisUser.RealName+' sent node message to #'+ Cstr(NodeToGet)+' .');

End;

Function CheckFile(FileType : Byte; MsgFName : String) : Boolean;


Var
  T  : Text;
  Fn : String;
  Tmp,
  GonnaWrite,
  Done : Boolean;
  I    : Integer;

Begin
 Tmp := False;
 Fn := Systat.SemaPath;
  Case FileType of
     0:FN := FN +  MsgFName  ;
     1:FN := FN + 'SYSREAD.' +Cstr(Node);
     2:FN := FN + 'SYSWRITE.'+Cstr(Node);
     3:FN := FN + 'STRREAD.' ;
     4:FN := FN + 'STRWRITE.';
     5:FN := FN + 'MSGREAD.' ;
     6:FN := FN + 'MSGWRITE.';
      else Exit;
   End; { Case }

  GonnaWrite := (FileType in [0,2,4,6]);


      I := 0;
      Done := False;
      If Exist(Fn) then
       repeat
        Inc(I);
        Delay(500);
        If (I >= 20) AND (UserOn) Then
          Begin
           If pynq('File locked, retry? [y/N] ') then
              I := 0;
          End else Done := TRUE;
       Until (Not Exist(FN)) or (Done);
       If (GonnaWrite) And (EXist(Fn)) Then
         Tmp := False else  Tmp := (Exist(Fn));

  CheckFile := TMP;
End;

Function LockFile(FileType : Byte; MsgFName : String) : Boolean;


Var
  T  : Text;
  Fn : String;
  Tmp,
  Done : Boolean;
  I    : Integer;

Begin
 Fn := Systat.SemaPath;

  Case FileType of
     0:FN := FN +  MsgFName  ;
     1:FN := FN + 'SYSREAD.' +Cstr(Node);
     2:FN := FN + 'SYSWRITE.'+Cstr(Node);
     3:FN := FN + 'STRREAD.' ;
     4:FN := FN + 'STRWRITE.';
     5:FN := FN + 'MSGREAD.' ;
     6:FN := FN + 'MSGWRITE.';
      else Exit;
   End; { Case }

     Done := False;
     Tmp := False;
     I := 0;
     assign(T,FN);
     {$i-} reset(t); {$I+}
     If (IoResult <> 2) then
       repeat
        Inc(I);
        Delay(500);
        If (I >= 20) AND (UserOn) Then
          Begin
           If pynq('File locked, retry? [y/N] ') then
              I := 0;
          End else Done := TRUE;
       Until (Not Exist(FN)) or (Done);

    If (Not Exist(FN)) then
       Begin
        rewrite(T);
        Tmp := TRUE;
       End else Tmp := False;

        Close(t);
   LockFile := Tmp;
End;

End.                     { END OF UNIT }
