{ NameFix - fixes the Names.LST after users are deleted and such }
{                                                                }
{                                                                }
{                                                                }
{                                                                }
{$A+,B+,D-,E+,F+,I+,L-,N-,O-,R-,S+,V-}

Uses Dos,OpCrt,StartUp1,Common,Date_Tim;

Procedure Create_Names;
Var
 User    : UserRec;
 SUser   : SmalRec;
Begin
 RandomIze;
 Assign(Uf,systat.GfilePath+'user.lst');
 {$i-} reset(Uf); {$I+}
  if (IoResult <> 0) then
    Begin
     writeln('User.Lst not found... Halting!');
     Halt(254);
    End;
  Assign(Sf,systat.GfilePath+'Names.Lst');
  rewrite(Sf);
  While not Eof(Uf) do
   Begin
    Read(Uf,User);
     SUser.Name     := User.Name;
     Suser.RealName := User.RealName;
     SUser.Number   := FilePos(Uf)-1;
    Write(Sf,SUser);
    TextAttr := Random(15)+1;
 if (FilePos(Uf)-1 <> 0) then
    writeln('User;  Alias:',User.Name,' RealName:',User.Realname,' U#',FilePos(Uf)-1);
   End;
   Close(Uf);
   Close(Sf);
End;


Procedure DeleteOld(Oldest : Integer);
Var
 User    : UserRec;
 Str     : String;
Begin
 writeln('Deleting users that have not called in <',Oldest,'> days.');
 Assign(Uf,systat.GfilePath+'user.lst');
 {$i-} reset(Uf); {$I+}
  if (IoResult <> 0) then
    Begin
     writeln('User.Lst not found... Halting!');
     Halt(254);
    End;
    Read(Uf,User);
    Randomize;
    While Not Eof(Uf) Do
      Begin
         Read(Uf,User);
         writeln(User.Name);
         Str := User.LastOn;
         Insert('19',Str,7); { this is so date is 00/00/1900 }
         If (Since_Date(Str,DateNowMail,2) > Oldest) then
         Begin
          if Not (fnodeletion in User.AC) then
           Begin
           TextAttr := Random(15)+1;
            Writeln('Marking Deleted; User#',FilePos(Uf)-1,' Name :',User.Name);
             User.Name :='';
             User.RealName := '';
             User.Ac := [];
             User.Deleted := TRUE;
             Seek(Uf,FilePos(Uf)-1);
             write(Uf,User);
           End;
         End;
      End;
    Close(Uf);
End;



Procedure NameFix_1;
Begin
   TextAttr := 14;
    writeln;
    writeln('Rebuilding NAMES.LST......');
    writeln;
   Create_Names;
    writeln;
    writeln;
   TextAttr := 12;
    writeln('Complete with NAMES.LST.');
End;

Procedure Delete_Old(i : Integer);
Begin
   TextAttr := 14;
    writeln;
    writeln('Rebuilding USER.LST......');
    writeln;
 DeleteOld(i);
    writeln;
    writeln;
   TextAttr := 12;
    writeln('Complete with USER.LST.');
End;

Procedure ShowHelp;
Begin
 Window(1,1,80,25);
 ClrScr;
 TextAttr := 15;
 writeln;
 writeln('UTOOLS Command line menu and Examples');
 writeln;
 writeln('/DXXX = Delete User that have not called in XXX days.');
 writeln('/N    = Re-create NAMES.LST file.');
 writeln;
 writeln('Example to delete user whom have not called in 60 days AND re-create'+
          ' NAMES.LST');
 writeln('Utools /D60 /N');
End;



Var
 Tmp,
 Str  : String;
 i    : Integer;

begin
   StartUp;  { StartUp1 }
  Window(1,1,80,5);
   TextAttr := 15;
   writeln;
   writeln(Centre('UTOOLS written by Mike Wilson, for ShadowBBS'));
  window(1,6,80,25);
  Str :='';
  if ParamCount <> 0 then
  Begin
  for I := 1 to ParamCount do
      Str := Str + AllCaps(ParamStr(i));
      if (pos('/D',Str) <> 0 )then
         Begin
           Tmp := Copy(Str,Pos('/D',Str)+2,Length(Str));
           i := 1;
           while (Tmp[i] <> ' ') and (i <= Length(Tmp)) do
            Inc(i);
           Tmp := Copy(Tmp,1,i-1);

          Delete_Old(Value(Tmp));
       End;
      if (Pos('/N',Str) <> 0) then
         NameFix_1;
      if (pos('/?',Str) <> 0) or
         (POs('/H',Str) <> 0 )then
         ShowHelp;
   End else { ParamCount <> 0 }
    ShowHelp;
End.


